<script setup lang="ts">
import { ref } from 'vue';

interface AccordionItem {
  header: string;
  content: string;
  icon?: string;
  expanded?: boolean;
}
interface FaqProps {
  header: string;
  accordion: Array<AccordionItem>;
  showAll: string;
  hideAll: string;
  config?: {
    theme?: string;
    id?: string;
  };
}

const props = defineProps<FaqProps>();
const isOpenIndex = ref<number | null>();
const allExpanded = ref<boolean | null>(false);
const toggleController = (index: number) => {
  isOpenIndex.value = isOpenIndex.value === index ? null : index;
};
const toggleAll = () => {
  allExpanded.value = !allExpanded.value;
  props.accordion.forEach((item) => {
    item.expanded = item.expanded ? !item.expanded : true;
  });
};
</script>

<template>
  <section :id="config?.id" class="faq slp-py-96 video-card" :class="`faq--${config?.theme}`">
    <SlpContainer data-aos="fade-up" data-aos-duration="1200" data-aos-offset="200">
      <div class="faq__header slp-py-16">
        <SlpTypography class="" variant="heading2-bold" tag="h2">
          {{ header }}
        </SlpTypography>
        <button type="button" class="faq__action" @click="toggleAll()">
          <SlpTypography class="group-control" variant="body2-bold" role="button" :aria-label="`Expand all items.`">
            {{ allExpanded ? hideAll : showAll }}
          </SlpTypography>
        </button>
      </div>

      <CommonAccordion
        v-for="(item, index) in accordion"
        :key="item.header"
        :data="item"
        :is-open="item.expanded || index == isOpenIndex"
        @toggle-controller="toggleController(index)"
      >
        <template #header>
          <SlpTypography variant="body1-bold">
            {{ item.header }}
          </SlpTypography>
        </template>
      </CommonAccordion>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.faq {
  &__header {
    display: flex;
    align-items: center;
    justify-content: space-between;
    border-bottom: 1px solid #a2a1a6;
  }
  &__action {
    color: $color-text-link-100;
    cursor: pointer;
    text-decoration: underline;
    font-weight: 600;
    white-space: nowrap;
    border: none;
  }
  &--dark {
    color: #fff;
    background-color: $color-primary-200;
  }
  :deep(.accordion) {
    border-bottom: 1px solid #45424d;
    .accordion__summary {
      padding: 20px 0;
    }
    .accordion__icon {
      color: currentColor;
      &:before,
      &:after {
        background-color: currentColor;
      }
    }
    .content {
      padding-bottom: 16px;
      color: #a2a1a6;
    }
  }
}
</style>
